/**
 * @file modinst.c
 *
 * @brief Driver installation program.
 *
 * @author Georgievskiy Yury. CERN BE/CO.
 *
 * @date August, 2004
 *
 * This program is automatically generated by the @b DriverGen.
 * Used to install Lynx/Linux driver in the system.
 *
 * @version 2.0 ygeorgie 30/10/07 Unlimited module amount installation
 *                                supported. Linux list is used.
 * @version 1.0 ygeorgie 23/08/04 Initial version.
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/dir.h>		/* for struct direct and readdir */
#include <sys/utsname.h>	/* for uname */
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <dlfcn.h>

#ifdef __Lynx__
#include <io.h>			/* for CHARDRIVER definition */
#else
#include <libgen.h>		/* for basename */
#define BLOCKDRIVER 1
#define CHARDRIVER  0
#endif

#include "modinst.h"

#define MIN_I_VECTOR 64		/* MIN possible interrupt vector */
#define MAX_I_VECTOR 256	/* MAX possible interrupt vector */

#define MIN_I_LEVEL  1		/* MIN interrupt processing hardware level */
#define MAX_I_LEVEL  7		/* MAX interrupt processing hardware level */

/* to suppress 'implicit declaration' warnings, and 'undefined vars' errors */
extern int dr_install(char *, int);
extern int cdv_install(char *, int, int);
#ifdef __linux__
#include "extra-linux.h"
#endif

/*======================Global data==========================================*/
char progName[DDNMSZ];		/* program name */

static char drvrTag[2][32] = {
	"Simulator",	/* simlator indication */
	"Driver"	/* driver indication */
};

/* default module parameters */
static struct mod_descr emptyModule;

LIST_HEAD(glob_md_list);	/* linked list of declared modules */
/*==================END of global data=======================================*/

static rslts parse_prog_args(int, char *[]);
static rslts final_param_setup();
static void  DisplayUsage(void);
static void  ParseIopt(DevInfo_t *);
static rslts RawModDescSet(struct mod_descr *);
static int   do_installation(void);
static rslts get_def_val_from_db_file(DevInfo_t *);
static void  init_module_descr(struct mod_descr *);
static int   install_driver(int, char *, uint *);
static void  do_cleanup(void);
static void  exploitInfoFile(DevInfo_t *);
static int   drvr_pathname(char *, char *);
static void* open_uso(void);
static int   usr_prologue(void *);
static int   usr_epilogue(void *);

int main(int argc, char *argv[], char *envp[])
{
	void *dllh;

	strncpy(progName, basename(argv[0]), sizeof(progName));
	printf("\n%s started...\n", progName);
	umask(0000); /* we need _exact_ mode for mknod */

	init_module_descr(&emptyModule);	/* set empty module param */

	/* check and set program arguments */
	if (parse_prog_args(argc, argv) || get_def_val_from_db_file(NULL))
		goto exit_failure;

	dllh = open_uso(); /* hook the user */

	/* final parameter setup and checking */
	if (final_param_setup()) {	/* module declaration error */
		fprintf(stderr, "%s: %sInstallation impossible. Incorrect"
			" input parameters.\nTry %s -h for more help.\n",
			progName, ERR_MSG, progName);
		goto exit_failure;
	}

	if (dllh) usr_prologue(dllh);

	if (!do_installation()) /* install */
		goto exit_failure;

	if (dllh) usr_epilogue(dllh);

	do_cleanup();
	if (dllh) dlclose(dllh);
	exit(EXIT_SUCCESS);	/* 0 */

      exit_failure:
	do_cleanup();
	if (dllh) dlclose(dllh);
	exit(EXIT_FAILURE);	/* 1 */
}

/**
 * @brief Parse command line arguments and fill in device description
 *        with raw data.
 *
 * @param argc -- command line argument count
 * @param argv -- command line argument array
 *
 * This data will be checked later by another function (namely
 * @e final_param_setup() ) to see if it is correct.
 *
 * @return RES_OK   - if everything is OK.
 * @return RES_FAIL - otherwise. Printout error info.
 */
static rslts parse_prog_args(int argc, char *argv[])
{
	int cmdOpt;
	uint isSet;		/* module description is saved already */
	int argCntr = 0;	/* counter of non-option args */
	char mas[MAX_STR] = { 0 };	/* to hold command options */
	rslts retCode = RES_OK;	/* return code */
	struct mod_descr moduleParam = emptyModule; /* current module.
						  Set to empty */
	DevInfo_t *dInfoPtr = &(moduleParam.infoTab);

	/* try to get default module name from cwd */
	set_def_mn(mas);

	/* Scan params of the command line */
	while ((cmdOpt = getopt(argc, argv, "-U:O:M:L:V:T:I:C:h,e")) != EOF
	       && retCode == RES_OK) {
		isSet = FALSE;	/* module descr is not saved yet */
		switch (cmdOpt) {
#ifdef __Lynx__
		case 0:	/* this is non-option arg -- module name */
#else	/* __linux__ */
		case 1:
#endif
			if (argCntr == 1)
				break;
			strncpy(mas, optarg, MAX_STR);
			argCntr++;
			break;
		case 'h':	/* Help information */
			DisplayUsage();
			do_cleanup();	/* just in case... */
			exit(EXIT_SUCCESS);	/* 0 */
			break;
		case 'e': /* exploit info file */
			{
				DevInfo_t locit;
				if (!mas[0]) {	/* module name is expected */
					do_cleanup();	/* just in case... */
					printf("%sNo Module name provided.\n",
					       ERR_MSG);
					exit(EXIT_FAILURE);	/* 1 */
				}
				if (db_mod_name(mas, TRUE) == (char *)-1) {
					/* provided module name is wrong */
					do_cleanup(); /* just in case... */
					exit(EXIT_FAILURE); /* 1 */
				}
				if (get_def_val_from_db_file(&locit)
				    != RES_OK) {
					do_cleanup();	/* just in case... */
					exit(EXIT_FAILURE);	/* 1 */
				}
				exploitInfoFile(&locit);
				do_cleanup();
				exit(EXIT_SUCCESS);	/* 0 */
				break;
			}
		case 'U':	/* Logical Unit Number. Compulsory option. */
			moduleParam.lun = atoi(optarg);
			break;
		case 'O':	/* First base address */
			dInfoPtr->addr1.baseAddr = strtol(optarg, NULL, 16);
			break;
		case 'M':	/* Second base address */
			dInfoPtr->addr2.baseAddr = strtol(optarg, NULL, 16);
			break;
		case 'L':	/* Interrupt level */
			dInfoPtr->iLevel = atoi(optarg);
			break;
		case 'V':	/* Interrupt vector */
			dInfoPtr->iVector = atoi(optarg);
			break;
		case 'T':	/* Transparent driver parameter */
			strncpy(dInfoPtr->opaque, optarg,
				sizeof(dInfoPtr->opaque));
			/* insure null-terminate */
			dInfoPtr->opaque[sizeof(dInfoPtr->opaque) - 1] = 0;
			break;
		case 'I':	/* Debug information printing */
			ParseIopt(dInfoPtr);
			break;
		case 'C': /* Channel amount
			     (amount of minor devices to create) */
			moduleParam.chan = atoi(optarg);
			break;
		case ',':	/* End of module device definition */
			isSet = TRUE;
			retCode = RawModDescSet(&moduleParam);
			moduleParam = emptyModule;	/* reset to empty */
			break;
		case '?':	/* error */
			printf("Try \'%s -h\' for help.\n", progName);
			return  RES_FAIL;
			break;
		default:
			break;
		}
	}

	if (!isSet)		/* we neet to set the last module config */
		retCode = RawModDescSet(&moduleParam);

	if (retCode != RES_OK)	/* something went wrong - abort */
		return RES_FAIL;

	if (!mas[0]) {		/* At least module name is expected */
		printf("%sModule Name is not provided.\nTry \'%s -h\' for"
		       " help.\n", ERR_MSG, progName);
		return RES_FAIL;
	}

	/* Now build-up global names: */

	/* 0x0. set module name global variable (exact as in the DataBase) */
	if (db_mod_name(mas, TRUE) == (char *)-1)
		/* provided module name is wrong, barf */
		return RES_FAIL;

	return RES_OK;
}

/**
 * @brief Final check of provided device parameters.
 *
 * @param none
 *
 * Checks if all needed parameters are provided, if this parameters are correct
 * and therefore if the module driver and devices can be installed.
 *
 * @return RES_FAIL - if any error occurs. Printout error info.
 * @return RES_OK   - if all modules were declared properly.
 */
static rslts final_param_setup()
{
	int cntr;
	struct mod_descr *mdp, *tmpTp;	/* module descripion pointers */
	rslts retStat;

	/*
	   +------------------------------------------------------------------+
	   | Pass throught all defined module devices. In case of real driver |
	   | installation - all the parameters should be checked. In case of  |
	   | simulator installation - address parameters are                  |
	   | irrelevant (i.e. '-O' and '-M' options).                         |
	   +------------------------------------------------------------------+
	*/
	list_for_each_entry(mdp, &glob_md_list, mod_list) {
		cntr++;
		retStat = RES_OK;

		/* 0x0. Check if LUN is provided. (Compulsory '-U' option) */
		if (mdp->lun == emptyModule.lun) {
			printf
			    ("%s: %sLogical Unit Number (LUN) is not provided."
			     " (device definition number %d).\n",
			     progName, WARNING_MSG, cntr);
			return  RES_FAIL;
		}

		/* 0x1. Set Driver/Simulator indication */
		if (mdp->lun < 0) {	/* User need driver simulator */
			mdp->isDrvr = FALSE;	/* this is Simulator */
			/* no base addresses */
			mdp->infoTab.addr1.baseAddr = ADCG__NO_ADDRESS;
			mdp->infoTab.addr2.baseAddr = ADCG__NO_ADDRESS;
		} else {	/* this is Driver */
			mdp->isDrvr = TRUE;
		}
		mdp->infoTab.mlun = mdp->lun;	/* setup LUN */

		/* 0x2. Check minor device numbers amount, i.e. channels amount
		   ('-C' option) If not within range - force it to one */
		if (!WITHIN_RANGE(1, mdp->chan, MI_MAX_CHAN)) {
			printf
			    ("%s: %s(LUN %d) Provided channel count (%d) is"
			     " out of range [1 - %d]. Force it to 1!\n",
			     progName, WARNING_MSG, mdp->lun, mdp->chan,
			     MI_MAX_CHAN);
			mdp->chan = 1;
		}
		mdp->infoTab.chan = mdp->chan;	/* set minor dev amount */

		/* 0x3. Check interrupt processing hardware level.
		   ('-L' option) */
		if ((!WITHIN_RANGE
		     (MIN_I_LEVEL, mdp->infoTab.iLevel, MAX_I_LEVEL))
		    && (mdp->infoTab.iLevel != emptyModule.infoTab.iLevel)) {
			printf
			    ("%s: %s(LUN %d) Provided Interrupt processing"
			     " hardware level (%d) is out of range"
			     " [%d - %d].\n",
			     progName, ERR_MSG, mdp->lun, mdp->infoTab.iLevel,
			     MIN_I_LEVEL, MAX_I_LEVEL);
			retStat = RES_FAIL;
		}

		/* 0x4. Check device interrupt vector. ('-V' option) */
		if ((!WITHIN_RANGE
		     (MIN_I_VECTOR, mdp->infoTab.iVector, MAX_I_VECTOR))
		    && (mdp->infoTab.iVector != emptyModule.infoTab.iVector)) {
			printf
			    ("%s: %s(LUN %d) Provided Interrupt vector (%d) is"
			     " out of range [%d - %d].\n",
			     progName, ERR_MSG, mdp->lun, mdp->infoTab.iVector,
			     MIN_I_VECTOR, MAX_I_VECTOR);
			retStat = RES_FAIL;
		}

		/* 0x5. Check debug flag. ('-I' option) */
		if ((mdp->infoTab.debugFlag) & DBGERR) {
			printf
			    ("%s: %s(LUN %d) Incorrect Debug info printing"
			     " flag.\n",
			     progName, WARNING_MSG, mdp->lun);
			retStat = RES_FAIL;
		}

		if (mdp->isDrvr == FALSE)	/* this is simulator */
			continue;/* the rest information is irrelevant in
				    this case */

		/* 0x6. Check if at least one address is provided.
		   ('-O' and '-M' options) */
		if ((mdp->infoTab.addr1.baseAddr ==
		     emptyModule.infoTab.addr1.baseAddr)
		    && (mdp->infoTab.addr2.baseAddr ==
			emptyModule.infoTab.addr2.baseAddr)) {
			printf
			    ("%s: %s(LUN %d) At leats one addres"
			     " (base or next) should be provided.\n",
			     progName, WARNING_MSG, mdp->lun);
			retStat = RES_FAIL;
		}

		if (retStat == RES_FAIL)
			return  RES_FAIL;/* error detected - return */
	}			/* end of 'list_for_each_entry' */

	/*
	   +------------------------------------------------------------------+
	   | Now check if correctly defined module devices don't collide with |
	   | each other. Declared devices should have different LUN's, Base   |
	   | Addresses, Second Addresses and different interrupt vectors in   |
	   | case of installation, and in case of deinstallation - only LUN's |
	   | are matters. They should be different for each device.           |
	   +------------------------------------------------------------------+
	*/
	list_for_each_entry(mdp, &glob_md_list, mod_list) {

		tmpTp = NULL;
		tmpTp = list_prepare_entry(tmpTp, &mdp->mod_list, mod_list);

		list_for_each_entry_continue(tmpTp, &glob_md_list, mod_list) {
			retStat = RES_OK;

			/* 00. Check LUN */
			if (mdp->lun == tmpTp->lun) {
				printf
				    ("%s: %sIdentical LUN = %d detected."
				     " Must be uique for each declared module"
				     " device.\n",
				     progName, WARNING_MSG, mdp->lun);
				retStat = RES_FAIL;
			}

			/* 01. Check first base address. '-O' option. */
			if (mdp->infoTab.addr1.baseAddr !=
			    emptyModule.infoTab.addr1.baseAddr) {
				/* it is defined */
				if (mdp->infoTab.addr1.baseAddr ==
				    tmpTp->infoTab.addr1.baseAddr) {
					printf
					    ("%s: %s(LUN %d) Identical Base"
					     " VME address (addr1) detected."
					     " Each declared module device"
					     " must have unique"
					     " Base address.\n",
					     progName, WARNING_MSG, mdp->lun);
					retStat = RES_FAIL;
				}
			}

			/* 02. Check second base address. '-M' option. */
			if (mdp->infoTab.addr2.baseAddr !=
			    emptyModule.infoTab.addr2.baseAddr) {
				/* it is defined */
				if (mdp->infoTab.addr2.baseAddr ==
				    tmpTp->infoTab.addr2.baseAddr) {
					printf
					    ("%s: %s(LUN %d) Identical Second"
					     " VME address of memory part"
					     " (addr2) detected. Each declared"
					     " module device must have unique"
					     " Second address.\n",
					     progName, WARNING_MSG, mdp->lun);
					retStat = RES_FAIL;
				}
			}

			/* 03. Check interrupt vector. '-V' option */
			if (mdp->infoTab.iVector !=
			    emptyModule.infoTab.iVector) {
				/* it is defined */
				if (mdp->infoTab.iVector ==
				    tmpTp->infoTab.iVector) {
					printf
					    ("%s: %s(LUN %d) Identical"
					     " Interrupt vector detected."
					     " Must be unique for each "
					     "declared module device.\n",
					     progName, WARNING_MSG, mdp->lun);
					retStat = RES_FAIL;
				}
			}

			if (retStat == RES_FAIL)
				/* device declaration error detected - abort */
				return RES_FAIL;
		}		/* end of 'list_for_each_entry_continue' */

		/* set device name */
		strncpy(mdp->name, BuildDevNm(mdp->lun, NULL),
			sizeof(mdp->name));

	} /* end of 'list_for_each_entry' */

	return RES_OK;
}

/**
 * @brief Guess what...
 */
static void DisplayUsage()
{
	printf("Usage:\n=> %s%s%s <module_name> -e { -U<lun> [ -O<addr>"
	       " | -M<addr> ] -L<n> \\\n    -V<n> -I<inst,deinst,ioctl,time,"
	       "infot,all> -T<str> } { -, DeviceN ... }\n\n",
	       WHITE_CLR, progName, END_CLR);
	printf(" Arguments are:\n");
	printf(" <module_name> %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Name of the module, for which driver and devices should be"
	       " inststalled.\n    It should be exactly as in the"
	       " DataBase.\n    If <module_name> is not provided, will try to"
	       " get it from cwd,\n    by analyzing *.info && *.ko "
	       "files.\n    If some ambiguity encounts (i.e. several *.info "
	       "files, several *.ko\n    for different module types etc...), "
	       "program will complain and stop.\n    In this case you should"
	       " help it and provide <module_name> explicitly\n    in the"
	       " command line.\n");
	printf(" -e %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Exploit module .info file content. Useful for debug "
	       "purposes.\n\n");
	printf(" Next that comes - is a description of each device that user"
	       " wants to install.\n Each module device description should be"
	       " seprated by '-,' (minus comma).\n If module driver is already"
	       " installed in the system, then it will not be\n re-installed,"
	       " but will be used by newly installed devices. If you want to"
	       " use\n new driver - first de-install the old one. It's"
	       " possible to have only one\n installed driver for the given"
	       " module in the system.\n If module devices with the given"
	       " LUN's (that user specify in the command line)\n are already"
	       " installed in the system, then such requested devices will not"
	       " be\n installed.\n");
	printf(" -U %sCompulsory%s\n", WHITE_CLR, END_CLR);
	printf("    Denotes the Logical Unit Number (LUN) assigned to the"
	       " declared device\n    (the module device address as seen by"
	       " the program level).\n    !NOTE! Special case (when LUN < 0)"
	       " is possible. In this case NOT Driver\n           but Driver"
	       " Simulator will be installed in the kernel. All address\n"
	       "           parameters are optional in the case of Driver"
	       " Simulator. I.e Base\n           address ('-O' option) and"
	       " Second address ('-M' option) are ignored\n           even if"
	       " they are provided.\n");
	printf(" -O %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Base VME module device address (in HEX). If not"
	       " specified - then default\n    value will be taken from the"
	       " module info file. Can be with or without\n    leading '0x'"
	       " prefix.\n");
	printf(" -M %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Second VME module device address (in HEX). If not"
	       " specified - then default\n    value will be taken from the"
	       " module info file. Can be with or without\n    leading '0x'"
	       " prefix.\n");
	printf(" -L %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Provides the level to process the module interrupt.\n");
	printf(" -V %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Provides the vector generated at interrupt.\n");
	printf(" -C %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Amount of minor devices (channel count).\n");
	printf(" -I %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Debug information output to console. Possible values"
	       " are:\n    'inst'   - debug output during driver"
	       " installation.\n    'deinst' - debug output during driver"
	       " deinstallation.\n    'ioctl'  - debug output during driver"
	       " ioctl routine\n    'time'   - display register accessing"
	       " time.\n    'infot'  - printout devinfo table content during"
	       " install phase.\n               Works ONLY if -Iioctl option"
	       " is set.\n    'all'    - all debug info is printout to"
	       " console.\n    They can be combined together using comma"
	       " (i.e. ',') as a separator.\n    !NOTE! Debug printout"
	       " tremendously slows down the driver. Not\n"
	       "           recommended to use in operational drivers.\n");
	printf(" -T %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Provides transarent parameter, that is intendent for the"
	       " driver only.\n    Parameter is passing to the driver as a"
	       " character string.\n");
	printf(" -, %sModule declaration separator%s\n", WHITE_CLR, END_CLR);
	printf("    Separates module parameters in case if several modules"
	       " should be\n    installed.\n\n");
	printf("  Examples:\n    %s%s%s SHARED_CIBC -U0 -O0x120000 -V128"
	       " -C1 -Iinst,deinst \\\n\t\t -T\"some info for the driver\" -,"
	       " -U2 -O0x130000 -, -U1 \\\n\t\t -O170000 -V140\n"
	       "    %s%s%s SHARED_CIBC -U0 -C4 -, -U12 -, -U4 -M150000"
	       " -V167 -Iall\n    %s%s%s SHARED_CIBC -U-1 -, -U-8 -, -U12"
	       " -C15 -Iioctl,time,infot \\\n                 -, -U-4\n"
	       "    %s%s%s SHARED_CIBC -e\n\n",
	       WHITE_CLR, progName, END_CLR, WHITE_CLR, progName, END_CLR,
	       WHITE_CLR, progName, END_CLR, WHITE_CLR, progName, END_CLR);
}

/**
 * @brief Check if printout info flags are correct.
 *
 * @param devInfo - dev info table
 *
 * @return void
 */
static void ParseIopt(DevInfo_t * devInfo)
{
	char masAllIOpt[MAX_STR], *ptrOneIOpt;	/* info options */

	strncpy(masAllIOpt, optarg, sizeof(masAllIOpt));
	masAllIOpt[sizeof(masAllIOpt) - 1] = 0;	/* null-terminate */
	ptrOneIOpt = strtok(masAllIOpt, ",");
	while (ptrOneIOpt) {
		if (!strncmp(ptrOneIOpt, "all", strlen("all"))) {
			devInfo->debugFlag |= DBGALL;
			break;
		} else if (!strncmp(ptrOneIOpt, "inst", strlen("inst"))) {
			devInfo->debugFlag |= DBGINSTL;
		} else if (!strncmp(ptrOneIOpt, "deinst", strlen("deinst"))) {
			devInfo->debugFlag |= DBGDEINSTL;
		} else if (!strncmp(ptrOneIOpt, "ioctl", strlen("ioctl"))) {
			devInfo->debugFlag |= DBGIOCTL;
		} else if (!strncmp(ptrOneIOpt, "time", strlen("time"))) {
			devInfo->debugFlag |= DBGTIMESTAT;
		} else if (!strncmp(ptrOneIOpt, "infot", strlen("infot"))) {
			devInfo->debugFlag |= DBGALLDI;
		} else {	/* invalid flag  */
			devInfo->debugFlag |= DBGERR;
			break;
		}
		ptrOneIOpt = strtok(NULL, ",");
	}
}

/**
 * @brief Set raw description of the module.
 *
 * @param ptr -- module description
 *
 * Fills in global configuration table of VME crate until MAX module amount
 * will be reached. Perfoms no checking if parameters are correct.
 * It will be done later by @e final_param_setup() function.
 *
 * @return RES_FAIL - can't allocate
 * @return RES_OK   - otherwise.
 */
static rslts RawModDescSet(struct mod_descr *ptr)
{
	struct mod_descr *newMod = (struct mod_descr *)
		calloc(1, sizeof(*newMod));

	if (!newMod)
		return  RES_FAIL;	/* can't allocate */

	memcpy(newMod, ptr, sizeof(struct mod_descr));
	INIT_LIST_HEAD(&newMod->mod_list);
	list_add(&newMod->mod_list /*new */ , &glob_md_list /*head */ );
	return RES_OK;
}

/**
 * @brief Called after all major preparations for installation have been done.
 *
 * @param none
 *
 * Will install the driver (if it's not yet installed) and load modules
 * for the driver.
 *
 * @return Number of installed drivers.
 */
static int do_installation()
{
	int fdesc;
	int major;
	int cntr = 0, cntr1;	/* counters */
	int numFailMDev = 0;	/* install falue counter */
	int numInstMDev = 0;	/* counter of installed major devices */
	int cdv_dummy = 0;
	int localErr = 0;	/* node install failure counter */
	char infoFName[MAX_STR], devFName[MAX_STR];
	int dId = 0, sId = 0;	/* driver and simulator ID's  */
	int decD = 0, decS = 0;	/* user declared amount of driver/sim */
	char dNm[DDNMSZ], sNm[DDNMSZ];	/* driver and simulator names */
	char nodeNm[DDNMSZ];	/* node name */
	struct mod_descr *mdPtr;
	dev_desc dd;
	int devAm;		/* found device amount */
	uint devResent, simResent;

	/* find out what should be installed */
	list_for_each_entry(mdPtr, &glob_md_list, mod_list) {
		if (mdPtr->isDrvr)
			++decD;
		else
			++decS;
	}

	/* printout user request info */
	printf("%s: Installation of %d device(s) for %s module is requested.\n",
	       progName, list_capacity(&glob_md_list),
	       db_mod_name(NULL, FALSE));

	if (decD) {		/* find and install if needed, drivers */
		if ((dId = install_driver(1, dNm, &devResent)) == -1)
			return numInstMDev;
	}

	if (decS) {	/* find and install if needed, driver simulators */
		if ((sId = install_driver(0, sNm, &simResent)) == -1)
			return numInstMDev;
	}

	/* Loop to install as many major devices as modules declared */
	list_for_each_entry(mdPtr, &glob_md_list, mod_list) {
		++cntr;
		printf("%s: Installing device no.#%d named %s ...    ",
		       progName, cntr, mdPtr->name);
		fflush(stdout);
		strcpy(dd.dev_name, mdPtr->name);
		/* get specific device */
		if ((devAm = find_devices(-1, &dd, sizeof(dd))) == -1) {
			numFailMDev++;
			continue;	/* internal error */
		} else if (devAm) {
			printf("%sAlready installed in the system. Will not"
			       " be re-installed.\n", WARNING_MSG);
			numFailMDev++;
			continue;
		}

		/* generate 'info' file name */
		sprintf(infoFName, "/dev/%s", mdPtr->name);
		/* Create the file to save the info table */
		if ((fdesc = open(infoFName, O_WRONLY | O_CREAT, 0777)) < 0) {
#ifdef DEBUG_VERBOSE
			ISSUE_ERR();
#endif
			printf
			    ("\n%s: %s[ %s] Cannot create %s (LUN %d)"
			     " information table.\n",
			     progName, ERR_MSG, strerror(errno), mdPtr->name,
			     mdPtr->lun);
			numFailMDev++;
			continue;
		}

		/* Write info table in created 'info' file */
		if (write(fdesc, &(mdPtr->infoTab), sizeof(DevInfo_t)) !=
		    sizeof(DevInfo_t)) {	/* error occurs */
#ifdef DEBUG_VERBOSE
			ISSUE_ERR();
#endif
			printf("\n%s: %s[ %s] Cannot create %s (LUN %d)"
			       " information table.\n",
			       progName, ERR_MSG, strerror(errno), mdPtr->name,
			       mdPtr->lun);
			numFailMDev++;
			close(fdesc);
			continue;
		}

		/* close file descriptor */
		close(fdesc);

		/* Install Major device associated to each module */
		major = cdv_install(infoFName, (mdPtr->isDrvr) ? dId : sId,
				    cdv_dummy);
		if (major < 0) {
#ifdef DEBUG_VERBOSE
			ISSUE_ERR();
#endif
			printf("\n%s: %s[ %s] For %s (LUN %d) installation"
			       " impossible.\n",
			       progName, ERR_MSG, strerror(errno), mdPtr->name,
			       mdPtr->lun);
			unlink(infoFName);
			numFailMDev++;
			continue;
		} else
			printf(" Done.\n");	/* device created, so report */

		unlink(infoFName);	/* we don't need it anymore */
		localErr = 0;	/* reset */

		/* create as many minor devices (device nodes) as user
		   demands */
		for (cntr1 = 0; cntr1 < mdPtr->chan; cntr1++) {
			sprintf(devFName, "/dev/%s",
				BuildNodeNm(mdPtr->lun, cntr1, nodeNm));
			unlink(devFName); /* if already exist - delete it */
			printf("%s: Creating %s device node...   ", progName,
			       nodeNm);
			fflush(stdout);

			/* create driver nodes, starting from minor 1 */
			if (mknod(devFName, S_IFCHR | 0666,
				  (major << 8) + (cntr1+1)) < 0) {
				/* error */
#ifdef DEBUG_VERBOSE
				ISSUE_ERR();
#endif
				localErr++;
				printf(" Fails. %s[ %s]\n", ERR_MSG,
				       strerror(errno));
				continue;/* pass through all requested minor
					    dev number */
			}
			chmod(devFName, 0666);
			printf(" Done.\n");
		}

		if (localErr == cntr1) {
			/* fail to create even one device node */
			printf("%s: No nodes were created for %s device."
			       " Uninstall it...   ",
			       progName, mdPtr->name);
			fflush(stdout);
			cdv_uninstall((mdPtr->isDrvr) ? dId : sId);
			numFailMDev++;
			printf("Done.\n");
		}

		if (!localErr)	/* no error occurs, so increase counter */
			numInstMDev++;
	}			/* end of 'for' */

	if (!numInstMDev) {
		/* no devices were installed for this driver, so
		   try to uninstall it */
		printf("%s: No new devices were installed for %s module.\n",
		       progName, db_mod_name(NULL, FALSE));

		if (decD && devResent) {
			printf("%s: Trying to uninstall %s %s...   ", progName,
			       dNm, drvrTag[1]);
			fflush(stdout);
			if (dr_uninstall(dId))
				printf("Fails. %s[ %s]\n", ERR_MSG,
				       strerror(errno));
			else
				printf("Done.\n");
		}

		if (decS && simResent) {
			printf("%s: Trying to uninstall %s %s...   ", progName,
			       sNm, drvrTag[0]);
			fflush(stdout);
			if (dr_uninstall(sId))
				printf("Fails. %s[ %s]\n", ERR_MSG,
				       strerror(errno));
			else
				printf("Done.\n");
		}
	}

	/* All done, report to user */
	snprintf(devFName, sizeof(devFName), "%s installation results are:",
		 db_mod_name(NULL, FALSE));

	printf("\n%s\n", devFName);
	for (cntr = 0; cntr < strlen(devFName); cntr++)
		printf("-");

	if (!numInstMDev)
		printf("\nNo Devices installed.\n\n");
	else {
		printf("\n%d Device(s) installed.\n%s", numInstMDev,
		       (numFailMDev) ? "" : "\n");

		if (numFailMDev)
			printf("%s%d major Device(s) installation failed.\n\n",
			       WARNING_MSG, numFailMDev);
	}

	return numInstMDev;
}

/**
 * @brief Open info file with dataBase module description and set variables,
 *        that were not initialize by user, with default values.
 *
 * @param itp -- if not NULL - will just get info file data and return the
 *               pointer to it.
 *
 * @return RES_OK   - if everything is OK.
 * @return RES_FAIL - otherwise. Printout error info.
 */
static rslts get_def_val_from_db_file(DevInfo_t *itp)
{
	int fdesc, fSz;
	struct stat fSt;
	char fNm[64];		/* module info filename */
	DevInfo_t *devD, _dit;	/* device data from the info file */
	struct mod_descr *mdp;
	char *tmp = _ncf(db_mod_name(NULL, FALSE));

	/* Driver Gen info filename */
	sprintf(fNm, "%s.info", tmp);
	free(tmp);

	if ((fdesc = open(fNm, O_RDONLY)) < 0) {
		printf("%s: %sCan't open .info file '%s' for '%s' module.\n",
		       progName, ERR_MSG, fNm, db_mod_name(NULL, FALSE));
#ifdef DEBUG_VERBOSE
		ISSUE_ERR();
#endif
		return RES_FAIL;
	}

	fstat(fdesc, &fSt);
	fSz = fSt.st_size;

	devD = mmap(0, fSz, PROT_READ, MAP_SHARED, fdesc, 0);
	if (devD == MAP_FAILED) {
		perror("mmap()");
#ifdef DEBUG_VERBOSE
		ISSUE_ERR();
#endif
		return RES_FAIL;
	}

	close(fdesc);		/* we don't need it anymore */

	/* copy it locally */
	memmove(&_dit, devD, sizeof(*devD));
	munmap(devD, fSz);

#ifdef __linux__
	convert_dit(&_dit, NULL); /* convert to HBO */
#endif
	devD = &_dit;

	if (itp) {		/* just give it back */
		memmove(itp, devD, sizeof(*itp));
		goto alldone;
	}

	/* set default values for each defined module device */
	list_for_each_entry(mdp, &glob_md_list, mod_list) {
    /*=========================== addr1 =====================================*/
		if (mdp->infoTab.addr1.baseAddr == ADCG__NO_ADDRESS) {
			/* if here, then user doesn't provide initial
			   address with '-O' option */

			if (devD->addr1.baseAddr != ADCG__NO_ADDRESS)
				/*
				   If here, then default initial address is
				   provided in the dataBase and we should set
				   it for each of the modules.

				   Note, that address increment and INT vector
				   increment are taken in account.

				   Device Base Address will be set to initial
				   Base Address from the DB module description
				   plus (LUN * address_increment)

				   Device INT Vector will be set to initial
				   Vector plus (LUN * vector_increment)

				   Example:

				   Let's assume that
				   Vector == 176   Vector Increment = 2
				   Addr1 == 0x8000 Increment == 0x1000
				   Addr2 == 0x5000 Increment == 0x20

				   command line:
				   modinst SHARED_CIBC vme -U5 -, -U0 -, -U7

				   Assigned Base addresses && INT will be:
				   LUN#5
				   Addr1      == 0xd000 [ 0x8000 + (5*0x1000) ]
				   Addr2      == 0x50a0 [ 0x5000 + (5*0x20)   ]
				   INT Vector == 186    [ 176    + 5*2        ]

				   LUN#0
				   Addr1      == 0x8000 [ 0x8000 + (0*0x1000) ]
				   Addr2      == 0x5000 [ 0x5000 + (0*0x20)   ]
				   INT Vector == 176    [ 176    + 0*2        ]

				   LUN#7
				   Addr1      == 0xf000 [ 0x8000 + (7*0x1000) ]
				   Addr2      == 0x50e0 [ 0x5000 + (7*0x20)   ]
				   INT Vector == 190    [ 176    + 7*2        ]
				*/
				mdp->infoTab.addr1.baseAddr =
				    devD->addr1.baseAddr +
				    (devD->addr1.increment /* addr#1
							      increment */
				     * mdp->lun/*module LUN*/);
		}
		mdp->infoTab.addr1.range = devD->addr1.range;
		mdp->infoTab.addr1.increment = devD->addr1.increment;
		mdp->infoTab.addr1.dpSize = devD->addr1.dpSize;
		mdp->infoTab.addr1.addrModif = devD->addr1.addrModif;

    /*================================= addr2 ===============================*/
		if (mdp->infoTab.addr2.baseAddr == ADCG__NO_ADDRESS) {
			/* if here, then user doesn't provide next address
			   with '-M' option */
			if (devD->addr1.baseAddr != ADCG__NO_ADDRESS)
				/* if here, then default next address is
				   provided in the dataBase */
				mdp->infoTab.addr2.baseAddr =
				    devD->addr2.baseAddr +
				    (devD->addr2. increment /* addr#2
							       increment */
				     * mdp->lun/*module LUN*/);
		}

		mdp->infoTab.addr2.range = devD->addr2.range;
		mdp->infoTab.addr2.increment = devD->addr2.increment;
		mdp->infoTab.addr2.dpSize = devD->addr2.dpSize;
		mdp->infoTab.addr2.addrModif = devD->addr2.addrModif;

    /*========================== the rest ===================================*/
		mdp->infoTab.mtn = devD->mtn;
		if (mdp->infoTab.iLevel == emptyModule.infoTab.iLevel)
			/* set default */
			mdp->infoTab.iLevel = devD->iLevel;
		if (mdp->infoTab.iVector == emptyModule.infoTab.iVector)
			/* set default */
			mdp->infoTab.iVector =
			    devD->iVector + (devD->iVectorInc * mdp->lun);
		mdp->infoTab.iVectorInc = devD->iVectorInc;

		/* grasp channel amount setting */
		if (mdp->chan == emptyModule.chan)
			/* not provided in the command line - so use one
			   from the DB */
			mdp->chan = devD->chan;

		mdp->infoTab.chrindex = devD->chrindex;
		mdp->infoTab.regAmount = devD->regAmount;
		mdp->infoTab.maxRegSz = devD->maxRegSz;
		mdp->infoTab.blkAmount = devD->blkAmount;
		/* set dataBase register description */
		memmove(mdp->infoTab.regDesc, devD->regDesc,
			sizeof(REGDESC) * devD->regAmount);
		/* set dataBase block description */
		memmove(mdp->infoTab.blkDesc, devD->blkDesc,
			sizeof(BLKDESC) * devD->blkAmount);
	}

      alldone:
	return  RES_OK;
}

/**
 * @brief Set empty driver parameters.
 *
 * @param md -- struct to init
 *
 * @return void
 */
static void init_module_descr(struct mod_descr * md)
{
	DevInfo_t *ditptr = &(md->infoTab);

	memset(md, 0, sizeof(struct mod_descr));
	md->lun = NO_LUN;	/* Logical Unit Number not defined. */
	md->chan = -1;		/* amount of file handlers (channels) */
	md->isDrvr = -1;	/* it is not driver nor simulator */

	ditptr->addr1.baseAddr = ADCG__NO_ADDRESS;
	ditptr->addr2.baseAddr = ADCG__NO_ADDRESS;
	ditptr->mlun = NO_LUN;
	ditptr->debugFlag = DBGNONE;	/* by default - no debug printing */
	ditptr->iLevel = -1;
	ditptr->iVector = -1;
	ditptr->iVectorInc = -1;
	ditptr->chan = -1;
	ditptr->chrindex = -1;
}

/**
 * @brief Driver/Simulator installation routine
 *
 * @param typ     -- @b 1 for driver. @b 0 for simulator
 * @param retName -- returns driver/simulator name
 * @param resent  -- if driver was installed just now.\n
 *                   TRUE  - if driver was installed just now.\n
 *                   FALSE - driver is already installed.
 *
 * Check if driver is already installed in the system, and if
 * not - installing it with dr_install()
 * Name of driver is returned in @b retName. And the creation trace
 * (i.e. if driver was installed just now or it is already present in the
 * system and will be re-used) is returned in the @b resent parameter.
 * If it's TRUE - then driver was installed just now, if it is FALSE - then
 * such driver is already present in the system and his ID and name will be
 * returned.
 *
 * @return driver ID - is success.
 * @return -1        - if fails. Error is printing out to stderr.
 */
static int install_driver(int typ, char *retName, uint *resent)
{
	int dId;		/* newly installed driver ID */
	int drAm = 0;		/* driver amount */
	char dNm[DDNMSZ];	/* driver name */
	driv_desc drdesc[MAXMODNUM];	/* driver description */
	char path[MAX_STR] = { 0 };	/* pathname of the driver */

	drAm = find_driver(build_drvr_nm((typ) ? _DRVR_ : _SIML_, dNm),
			   drdesc, sizeof(drdesc));

	if (retName)
		strncpy(retName, dNm, sizeof(dNm));

	if (drAm < 0)
		return -1;	/* error */
	if (drAm > 1) {
		printf("%s: %s%d %s %ss detected. Uninstall them first.\n",
		       progName, WARNING_MSG, drAm, dNm, drvrTag[typ]);
		return -1;
	}

	if (drAm == 1) {
		printf("%s: %s%s %s already installed in the system."
		       " Will be re-used.\n",
		       progName, WARNING_MSG, dNm, drvrTag[typ]);
		*resent = FALSE;
		return drdesc[0].driv_id;
	}

	/* build-up driver pathname */
	if (drvr_pathname(path, dNm))
		return -1;

	/* Install the driver in the system kernel */
	printf("%s: %s is not installed in the system."
	       "  Trying to install %s...  ",
	       progName, drvrTag[typ], dNm);
	fflush(stdout);
	if ((dId = dr_install(path, CHARDRIVER)) < 0) {
		printf("\n%s: %s[%s] Cannot install %s %s.\n", progName,
		       ERR_MSG, strerror(errno), db_mod_name(NULL, FALSE),
		       drvrTag[typ]);
#ifdef DEBUG_VERBOSE
		ISSUE_ERR();
#endif
		return -1;
	}

	*resent = TRUE;
	printf("   Done.\n");	/* created. report to user */
	return dId;
}

/**
 * @brief Cleaning up. Deallocate all claimed resources.
 *
 * @param none
 *
 * @return void
 */
static void do_cleanup()
{
	struct mod_descr *mdp, *tmp;

	list_for_each_entry_safe(mdp, tmp, &glob_md_list, mod_list) {
		list_del(&mdp->mod_list);
		free(mdp);
	}
}

/**
 * @brief Exploit driver .info file
 *
 * @param info table to printout.
 *
 * Useful for debug purposes. User can check if info file contains
 * correct data.
 *
 * @return void
 */

static void exploitInfoFile(DevInfo_t * info)
{
	int cntr;
	AddrInfo_t *aiptr = &(info->addr1);
	REGDESC *rdp = info->regDesc;
	BLKDESC *bdp = info->blkDesc;

	printf("\n%s .info file data\n\n", db_mod_name(NULL, FALSE));
	/* general info */
	printf("+---- general info -----------\n");
	printf("| 'mtn'        => %d\n",   info->mtn);
	printf("| 'mlun'       => 0x%x\n", info->mlun);
	printf("| 'debugFlag'  => 0x%X\n", info->debugFlag);
	printf("| 'opaque'     => '%s'\n", info->opaque);
	printf("| 'iLevel'     => %d\n",   info->iLevel);
	printf("| 'iVector'    => %d\n",   info->iVector);
	printf("| 'iVectorInc' => %d\n",   info->iVectorInc);
	printf("| 'chan'       => %d\n",   info->chan);
	printf("| 'chrindex'   => %d\n",   info->chrindex);
	printf("| 'gen_date'   => %ld\n",  info->gen_date);
	printf("| 'dg_vers'    => '%s'\n", info->dg_vers);
	printf("| 'regAmount'  => %d\n",   info->regAmount);
	printf("| 'maxRegSz'   => %d\n",   info->maxRegSz);
	printf("| 'blkAmount'  => %d\n",   info->blkAmount);
	printf("| 'checksum'   => %d\n",   info->checksum);
	printf("+-----------------------------\n\n");

	/* 2 address space info */
	for (cntr = 0; cntr < 2; cntr++) {
		printf("+-----------------------------\n");
		printf("| Addr[%d].baseAddr  => 0x%lx\n", cntr,
		       aiptr->baseAddr);
		printf("| Addr[%d].range     => 0x%x\n", cntr, aiptr->range);
		printf("| Addr[%d].increment => 0x%x\n", cntr,
		       aiptr->increment);
		printf("| Addr[%d].dpSize    => %d\n", cntr, aiptr->dpSize);
		printf("| Addr[%d].addrModif => 0x%x\n", cntr,
		       aiptr->addrModif);
		printf("+-----------------------------\n\n");
		aiptr++;
	}

	/* all block info */
	for (cntr = 0; cntr < info->blkAmount; cntr++) {
		printf("+---------------------------------------------\n");
		printf("| Blk[%d].block       => %d\n", cntr, bdp[cntr].block);
		printf("| Blk[%d].blkBaseAddr => %d\n", cntr,
		       bdp[cntr].blkBaseAddr);
		printf("| Blk[%d].offset      => 0x%lX\n", cntr,
		       bdp[cntr].offset);
		printf("| Blk[%d].blksz_drvr  => %d bytes\n", cntr,
		       bdp[cntr].blksz_drvr);
		printf("| Blk[%d].blksz_sim   => %d bytes\n", cntr,
		       bdp[cntr].blksz_sim);
		printf("| Blk[%d].reg_am      => %d\n", cntr,
		       bdp[cntr].reg_am);

		printf("+---------------------------------------------\n\n");
	}

	/* all registers info */
	for (cntr = 0; cntr < info->regAmount; cntr++) {
		printf("+---------------------------------------------\n");
		printf("| Reg[%d].regId        => %d\n", cntr, rdp[cntr].regId);
		printf("| Reg[%d].regName      => %s\n", cntr,
		       rdp[cntr].regName);
		printf("| Reg[%d].busType      => %s\n", cntr,
		       rdp[cntr].busType);
		printf("| Reg[%d].regType      => %s (%d)\n", cntr,
		       (rdp[cntr].regType ==
			RT_REAL) ? "RT_REAL" : (rdp[cntr].regType ==
						RT_EXTR) ? "RT_EXTR" :
		       "RT_SRVS", rdp[cntr].regType);
		printf("| Reg[%d].regSize      => %d\n", cntr,
		       rdp[cntr].regSize);
		printf("| Reg[%d].b_a          => %s\n", cntr, rdp[cntr].b_a);
		printf("| Reg[%d].bid          => %d\n", cntr, rdp[cntr].bid);
		printf("| Reg[%d].regOffset    => 0x%X\n", cntr,
		       rdp[cntr].regOffset);
		printf("| Reg[%d].regDepth     => %d\n", cntr,
		       rdp[cntr].regDepth);
		printf("| Reg[%d].regtl        => %d\n", cntr, rdp[cntr].regtl);
		printf("| Reg[%d].regar        => %d\n", cntr, rdp[cntr].regar);
		printf("| Reg[%d].rwIoctlOpNum => 0x%x\n", cntr,
		       rdp[cntr].rwIoctlOpNum);
		printf("+---------------------------------------------\n\n");
	}
}

/**
 * @brief Search for the .ko in cwd, and if it is a symlink -- follows it.
 *
 * @param path -- result goes here
 * @param ko   -- driver name (as returned by build_drvr_nm())
 *                Ex: RfIrqTestS.ko
 *
 * [1] If driver is delivered -- then we should have 2 .ko object files in
 *     @ref DRVR_NAME_FMT format. Ex: SharedcibcS.ko
 *
 * [2] If drvier is compiled locally and is @b not delivered -- then we can have
 *     N | 2 .ko objects, which are symlinks. They contain 'uname -r' in their
 *     names. Ex: CtcD.2.6.29.4-rt15.ko.
 *     It points to the real .ko object of the format as in [1]
 *
 * [3] .ko names with 'uname -r' part in their names and without it -- can't
 *     co-exist. Directory considered to be a non-standard one.
 *
 * Function will detect the type, and if it's a symlink, will follow it.
 *
 * @return  0 -- all OK, can proceed with installation
 * @return -1 -- *.ko filename ambiguity, means that there are names with
 *               'uname -r' part in them, and there are one without it.
 * @return -2 -- can't read a symbolic link
 * @return -3 -- .ko doesn't exist
 */
static int drvr_pathname(char *path, char *ko)
{
	DIR *dir = opendir("./");
	struct direct *direntry = NULL;
	char fn[256];	/* symlink filename */
	struct utsname buf;
	int lko = 0, rko = 0;	/* .ko counters
				   lko - local .ko file
				   rko - remote .ko file (symlink) */

	uname(&buf);
	sprintf(fn, "%.*s.%s.ko", (rindex(ko, '.') - ko), ko, buf.release);

	/* *.ko && *.`uname -r`.ko can't co-exist together in one dir */
	while ( (direntry = readdir(dir)) ) {
		if (!strcmp(direntry->d_name, ko))
			++lko;
		if (!strcmp(direntry->d_name, fn))
			++rko;
	}
	closedir(dir);

	if (!lko && !rko) {
		printf("%sCan't find driver to load.\n"
		       "       [%s] and [%s] do not exist.\n",
		       ERR_MSG, ko, fn);
		return -3; /* .ko not found */
	}

	/* we should have at least one of them */
	if (lko == rko) {
		printf("%sAmbiguous *.ko filenames detected.\n"
		       "       [%s] and [%s] can't co-exist.\n",
		       ERR_MSG, ko, fn);
		return -1; /* both *.ko and *.`uname -r`.ko detected */
	}

	if (lko) {
		sprintf(path, "./%s", ko);
		return 0;
	}

	/* we have a symlink */
	if (readlink(fn, path, sizeof(fn)) == -1) {
		printf("%sCan't resolve %s symlink\n", ERR_MSG, fn);
		return -2;
	}

	return 0;
}

/**
 * @brief Will try to load user-provided shared library (if any)
 *
 * @param none
 *
 * First will try to load @b local .so with $(CPU) suffix in it
 * (i.e. ./lib<module>inst.$(CPU).so)
 * If not found -- will try to load @b local .so without $(CPU)
 * (i.e. ./lib<module>inst.so)
 * If none found -- will return NULL, meaning that user entry points
 * for installation routine will not be called.
 *
 * @return NULL   -- failed to load user shared lib
 * @return handle -- if OK
 */
static void* open_uso(void)
{
	char so[256]  = { 0 };/* user shared object */
	void *dllSo;
	struct utsname buf;

	uname(&buf);

	/* try to open local .so */
	sprintf(so, "./lib%sinst.%s.so", _ncf(db_mod_name(NULL, FALSE)),
		(!strcmp(buf.sysname, "Linux"))?"L865":"ppc4");
	dllSo = dlopen(so, RTLD_LAZY);

	if (!dllSo) {
		/* try to open delivered .so */
		memset(so, 0, sizeof(so));
		sprintf(so, "/usr/local/drivers/%s/lib%sinst.so",
			_ncf(db_mod_name(NULL, FALSE)),
			_ncf(db_mod_name(NULL, FALSE)));

		dllSo = dlopen(so, RTLD_LAZY);
	}

	if (dllSo) /* .so opened -- report */
		printf("Prologue/Epilogue functions will be called from %s\n",
		       so);

	return dllSo;
}

/**
 * @brief Call User Entry Point just before installing the driver
 *
 * @param dllh -- .so handle
 *
 * @return -1 -- dlsym() failed
 * @return  0 -- OK, user function called
 */
static int usr_prologue(void *dllh)
{
	int (*func) (struct list_head *);
	char sym[32] = { 0 };
	char *p = sym;

	p += sprintf(p, "%s_inst_", _ncf(db_mod_name(NULL, FALSE)));
	sprintf(p, "prologue");

	func = dlsym(dllh, sym);
	if (!func)
		return -1;

	/* call UEP */
	(*func)(&glob_md_list);
	return 0;
}

/**
 * @brief Call User Entry Point after driver is installed
 *
 * @param dllh -- .so handle
 *
 * @return -1 -- dlsym() failed
 * @return  0 -- OK, user function called

 */
static int usr_epilogue(void *dllh)
{
	int (*func) (struct list_head *);
	char sym[32] = { 0 };
	char *p = sym;

	p += sprintf(p, "%s_inst_", _ncf(db_mod_name(NULL, FALSE)));
	sprintf(p, "epilogue");

	func = dlsym(dllh, sym);
	if (!func)
		return -1;

	/* call UEP */
	(*func)(&glob_md_list);
	return 0;
}
